package com.TianGe9158;

public class AVInput {
	public AVModule m_AVModuel = null;
	public boolean m_bStop = false;
	boolean m_bInitAudio = false;

	int m_nCodec = 0;
	int m_nSampleRate = 0;
	int m_nChannels = 0;
	int m_nBitRate = 0;
	int m_nBitSample = 0;

	AudioIn m_AudioIn = null;

	public AVInput() {
		m_bStop = false;
	}

	public void Stop() {
		if (m_AudioIn != null) {
			m_AudioIn.Stop();
		}
	}

	public void Close() {
		CloseAudioIn();
	}

	public void CloseAudioIn() {
		if (m_AudioIn != null) {
			m_AudioIn.Stop();
			m_AudioIn.Close();
			m_AudioIn = null;
		}
	}

	public boolean CreateAudioIn() {
		CloseAudioIn();
		m_AudioIn = new AudioIn();
		m_AudioIn.m_avmodule = m_AVModuel;
		return m_AudioIn.Init(m_nCodec, m_nSampleRate, m_nChannels, m_nBitRate,
				m_nBitSample);
	}

	public boolean InitAudio(int nCodec, int nSampleRate, int nChannels,
			int nBitRate, int nBitSample, boolean bHaveAudioRecord) {
		m_nCodec = nCodec;
		m_nSampleRate = nSampleRate;
		m_nChannels = nChannels;
		m_nBitRate = nBitRate;
		m_nBitSample = nBitSample;
		if (!bHaveAudioRecord) {
			return CreateAudioIn();
		}
		return true;
	}

	public void AudioStop() {
		if (m_AudioIn != null) {
			m_AudioIn.Pause();
		}
	}

	public void AudioStart() {
		if (m_AudioIn != null) {
			m_AudioIn.Record();
		}
	}

}
