package com.TianGe9158;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;

public class AVModule extends Object {

	int m_handle = 0;
	Activity m_content;

	List<AVOutput> m_outputList = null;
	AVInput m_input = null;

	int m_nVideoCodec = 0;
	int m_nVideoWidth = 0;
	int m_nVideoHeight = 0;
	int m_nFrame = 0;
	int m_nQuality = 0;

	int m_nAudioCodec = 0;
	int m_nSamlpeRate = 0;
	int m_nChannels = 0;
	int m_nBitSample = 0;
	int m_nBitRate = 0;
	int m_nAudioFrameSize = 0;
	IAVCallback m_IAVCallback = null;

	byte[] m_defaultVideo = null;
	boolean m_bHaveVideo = true;
	// gf add
	// ++++++++++++++++++++++
	boolean m_bClose = false;
	VideoEncode0 m_VideoEncode = null;
	boolean nFirst = false;
	// +++++++++++++++++++++++++
	/*
	 * boolean m_bOutputStereoEffect = false; int m_nOutputStereoDelay = 5;
	 * float m_fOutputStereoBalance = (float) 0.7;
	 */

	public AVModule(Activity content) {
		Log.v("JNI_DEBUG", "1");
		m_content = content;
		m_outputList = new ArrayList<AVOutput>();
		Log.v("JNI_DEBUG", "2");
	}

	public void SetHaveVideo(boolean bHaveVideo) {
		m_bHaveVideo = bHaveVideo;
	}

	public void SetAVCallback(IAVCallback callback) {
		m_IAVCallback = callback;
	}

	public AVOutput GetOutput(int nUserID) {
		for (int i = 0; i < m_outputList.size(); i++) {
			if (m_outputList.get(i).m_nUserID == nUserID) {
				return m_outputList.get(i);
			}
		}
		return null;
	}

	public static void javaOnChangeOutputAVStatus(AVModule obj, int nUserID, int nAudio, int nVideo) {

	}

	public static void javaOnOutputVideoData(AVModule obj, int nUserID, byte[] videoBuf, int nLength) {

		AVOutput output = obj.GetOutput(nUserID);
		if (output != null) {
			output.AddVideoBuffer(videoBuf, nLength);
		}

		// Log.v("JNI_DEBUG", "java javaOnOutputVideoData");
	}


	public static int javaOnGetWaveOutPlayCount(AVModule obj, int nUserID) {
		AVOutput output = obj.GetOutput(nUserID);
		if (output != null)
			return output.GetWaveBufferCount();
		else
			return 0;
	}

	public static void javaOnOutputAuidoValue(AVModule obj, int nUserID, int nValue, int nValue1, byte[] audioBuf, int nLength,
			byte[] otherBuf, int nOtherLength) {

		AVOutput output = obj.GetOutput(nUserID);
		if (output != null) {
			output.AddAudioBuffer(audioBuf, nLength, otherBuf, nOtherLength);
		}

	}

	// gf add
	// ++++++++++++++++++++
	public static void javeOnVideoDataStatus(AVModule obj, int nUserID, boolean nStatus) {
		// Log.e("javeOnVideoDataStatus", "!!!!!nStatus"+nStatus);

		AVOutput output = obj.GetOutput(nUserID);
		if (output != null) {
			if ((obj.m_IAVCallback != null)) {
				output.SetVideoDataStatus(nStatus);
				if (nStatus) {
					obj.m_IAVCallback.OnVideoBufferComplete(nUserID);
				} else {
					obj.m_IAVCallback.OnVideoBufferUnComplete(nUserID);
				}

			} else {
				output.SetVideoDataStatus(true);
			}

		}

	}

	
	public static void javaOnVideoEncode(AVModule obj, byte[] videoBuf,int nLength)
	{
		Log.e("JNI_DEBUG", "DeleteOutput = " + "javaOnVideoEncode11111111111111");
		
	
		if(obj.nFirst == false)
		{
			obj.m_VideoEncode.InitParam(obj.m_nVideoWidth, obj.m_nVideoHeight, obj.m_nFrame, obj.m_nBitRate);//gf add
			obj.nFirst = true;
		}
	/*
		Log.e("JNI_DEBUG", "DeleteOutput = " + "javaOnVideoEncode222222222222222222222");
		if(obj.m_VideoEncode != null)
		{
			Log.e("JNI_DEBUG", "DeleteOutput = " + "22222222222222222222222");

			Log.e("JNI_DEBUG", "DeleteOutput = " + "3333333333");
			obj.m_VideoEncode.offerEncoder(videoBuf);
			
		}
		*/
		
	//	obj.m_IAVCallback.OnVideoBufferComplete(333);
	
	}
	// ++++++++++++++++++++++++++

	// ԭĽӿ
	private native int AVInit(AVModule avObj,
	// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int width, int height, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType);

	// Դ͸ߵĽӿ
	private native int AVInit(AVModule avObj,
	// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int nInWidth, int InHeight, int nOutWidth, int nOutHeight, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType);

	// urlӿ
	private native int AVInitURL(AVModule avObj,
			// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int nInWidth, int InHeight, int nOutWidth, int nOutHeight, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType,
			String pPlayURL);

	private native void AVClose(int handle);

	private native void AVInsertOutput(int handle, int userid);

	private native void AVDeleteOutput(int handle, int userid);

	private native void AVSetAudioStatus(int handle, int userid, int nAudio);

	private native void AVSetVideoStatus(int handle, int userid, int bVideo);

	private native int AVGetNetRate(int handle);

	private native int AVInsertInput(int handle);

	private native int AVAddAudioData(int handle, byte[] data, int dataLength, int frameLength);

	private native int AVAddAudioDataEx(int handle, byte[] data, int dataLength, byte[] otherData, int otherDataLength);

	private native int AVDeleteInput(int handle);

	private native void AVSetNS(int handle, int nRunNS);

	private native void AVSetBaseInfo(int handle, String szServerIP, int port, int roomid, int userid, int bufferTime);

	private native void AVSetInputAudioStatus(int handle, int nAudio);

	private native int AVAddVideoData(int handle, byte[] data, int dataLength, int nEncode, int nIFrame);

	// gf add 2016.7.22
	// ===================================================
	private native void AVSetRotateAngle(int handle, int nRotateAngle);

	private native void AVSetConverMode(int handle, int nConverMode);

	private native boolean AVIsInputVideoData(int handle);

	private native void AVSetMagicBeautyStatus(int handle, boolean bOpen);

	private native void AVSetMagicBeautyParam(int handle, float smoothlevel, float whitenlevel);

	private native void AVSetLogoType(int handle, int nLogoType); // 2016.12.08
	// ==================================================

	static {
		// Log.v("JNI_DEBUG", "AVModule load ....");
		try {
			System.loadLibrary("AVModule");
			Log.v("JNI_DEBUG", "AVModule load succ");
		} catch (UnsatisfiedLinkError ule) {
			// catch(Exception ule){
			Log.v("JNI_DEBUG", "AVModule load error");
			String ss = ule.getMessage();
			Log.v("JNI_DEBUG", ss);
			// Log.v("JNI_DEBUG", "1");
			// System.err.println("WARNING: Could not load library 12425242!");
		}
		// Log.v("JNI_DEBUG", "AVModule load ok");
	}

	public void SetBitmap(byte[] buffer) {
		m_defaultVideo = buffer.clone();
	}

	public boolean Init(
	// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int nInWidth, int nInHeight, int nOutwidth, int nOutHeight, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType) {
		m_nVideoCodec = videoCodec;

		m_nVideoWidth = nOutwidth;
		m_nVideoHeight = nOutHeight;
		m_nFrame = frame;
		m_nQuality = quality;

		m_nAudioCodec = audioCodec;
		m_nSamlpeRate = sampleRate;
		m_nChannels = channels;
		/*
		 * if (m_nAudioCodec == 1 || m_nAudioCodec == 5) m_nChannels = 1; else
		 * m_nChannels = channels;
		 */
		m_nBitRate = bitRate;
		m_nBitSample = bitSample;

		switch (audioCodec) {
		case 0:
			m_nAudioFrameSize = 2304 * 2;

			break;
		case 1:
		case 5:
		case 7:
			m_nAudioFrameSize = 1024 * 4 * m_nChannels;

			break;
		case 2:
			m_nAudioFrameSize = (sampleRate * 4) / 50;

			break;
		case 6:
			m_nAudioFrameSize = 512 * 4 * m_nChannels;

			break;

		default:
			m_nAudioFrameSize = 0;
			break;
		}

		m_handle = AVInit(this, szServerIP, port, roomid, userid, bufferTime, videoCodec, nInWidth, nInHeight, nOutwidth,
				nOutHeight, frame, quality, openVideo, audioCodec, sampleRate, m_nChannels, bitRate, bitSample, openAudio,
				nProtocolType);
		return m_handle != 0;
	}

	public boolean Init(
			// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int nInWidth, int nInHeight, int nOutwidth, int nOutHeight, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType,
			String pPlayURL) {
		m_nVideoCodec = videoCodec;
		m_nVideoWidth = nOutwidth;
		m_nVideoHeight = nOutHeight;
		m_nFrame = frame;
		m_nQuality = quality;

		m_nAudioCodec = audioCodec;
		m_nSamlpeRate = sampleRate;
		m_nChannels = channels;
		/*
		 * if (m_nAudioCodec == 1 || m_nAudioCodec == 5) m_nChannels = 1; else
		 * m_nChannels = channels;
		 */
		m_nBitRate = bitRate;
		m_nBitSample = bitSample;

		switch (audioCodec) {
		case 0:
			m_nAudioFrameSize = 2304 * 2;

			break;
		case 1:
		case 5:
		case 7:
			m_nAudioFrameSize = 1024 * 4 * m_nChannels;

			break;
		case 2:
			m_nAudioFrameSize = (sampleRate * 4) / 50;

			break;
		case 6:
			m_nAudioFrameSize = 512 * 4 * m_nChannels;

			break;

		default:
			m_nAudioFrameSize = 0;
			break;
		}

		// AVClose(0);
		// Log.v("JNI_DEBUG", "8888888888888888");
		m_handle = AVInitURL(this, szServerIP, port, roomid, userid, bufferTime, videoCodec, nInWidth, nInHeight, nOutwidth,
				nOutHeight, frame, quality, openVideo, audioCodec, sampleRate, m_nChannels, bitRate, bitSample, openAudio,
				nProtocolType, pPlayURL);
		return m_handle != 0;
	}

	public boolean Init(
	// server info
			String szServerIP, int port, int roomid, int userid, int bufferTime,
			// video info
			int videoCodec, int width, int height, int frame, int quality, int openVideo,
			// audio info
			int audioCodec, int sampleRate, int channels, int bitRate, int bitSample, int openAudio, int nProtocolType) {
		m_nVideoCodec = videoCodec;
		m_nVideoWidth = width;
		m_nVideoHeight = height;
		m_nFrame = frame;
		m_nQuality = quality;

		m_nAudioCodec = audioCodec;
		m_nSamlpeRate = sampleRate;
		m_nChannels = channels;
		/*
		 * if (m_nAudioCodec == 1 || m_nAudioCodec == 5) m_nChannels = 1; else
		 * m_nChannels = channels;
		 */
		m_nBitRate = bitRate;
		m_nBitSample = bitSample;

		switch (audioCodec) {
		case 0:
			m_nAudioFrameSize = 2304 * 2;

			break;
		case 1:
		case 5:
		case 7:
			m_nAudioFrameSize = 1024 * 4 * m_nChannels;

			break;
		case 2:
			m_nAudioFrameSize = (sampleRate * 4) / 50;

			break;
		case 6:
			m_nAudioFrameSize = 512 * 4 * m_nChannels;

			break;

		default:
			m_nAudioFrameSize = 0;
			break;
		}

		// AVClose(0);

		Log.e("JNI_DEBUG", "DeleteOutp");
		m_handle = AVInit(this, szServerIP, port, roomid, userid, bufferTime, videoCodec, width, height, frame, quality,
				openVideo, audioCodec, sampleRate, m_nChannels, bitRate, bitSample, openAudio, nProtocolType);
		return m_handle != 0;
	}

	private Boolean isLianMai = false;

	public void setShowWidthAndHeight(int userId, int nWidth, int nHeight) {
		if (m_outputList != null && m_outputList.size() > 0) {
			for (int i = 0; i < m_outputList.size(); i++) {
				if (m_outputList.get(i).m_nUserID == userId) {
					VideoPlay videoPlay = m_outputList.get(i).m_videoPlay;
					videoPlay.setRefreshUi(true);
					videoPlay.setNewWidth(nWidth);
					videoPlay.setNewHeight(nHeight);
					break;
				}
			}
		}
	}

	public Boolean getIsLianMai() {
		return isLianMai;
	}

	public void setIsLianMai(Boolean isLianMai) {
		this.isLianMai = isLianMai;
	}

	// gf add 2016.7.22
	// ==============================================
	public void SetRotateAngle(int nRotateAngle) {
		AVSetRotateAngle(m_handle, nRotateAngle);
	}

	public void SetConverMode(int nConverMode) {
		AVSetConverMode(m_handle, nConverMode);
	}

	public void SetMagicBeautyParam(float smoothlevel, float whitenlevel) {
		float tmpSmoothLevel = (smoothlevel - (float) 10.0) / (float) 500.0 * (float) 10.0;
		AVSetMagicBeautyParam(m_handle, tmpSmoothLevel, whitenlevel);
	}

	public void SetMagicBeautyStatus(boolean bOpen) {
		AVSetMagicBeautyStatus(m_handle, bOpen);
	}

	public void SetLogoType(int nLogoType) {
		AVSetLogoType(m_handle, nLogoType);
	}

	// ==================================================

	public void Close() {
		m_bClose = true;
		if (m_input != null)
			m_input.Stop();
		for (int i = 0; i < m_outputList.size(); i++) {
			m_outputList.get(i).Stop();
		}
		if (m_handle != 0) {
			AVClose(m_handle);
			m_handle = 0;
		}
		if (m_input != null)
			m_input.Close();
		m_input = null;
		for (int i = 0; i < m_outputList.size(); i++) {
			m_outputList.get(i).Close();
		}
		m_outputList.clear();
		m_content = null;

	}

	protected void StopAVOutput(int nUserID) {
		for (int i = 0; i < m_outputList.size(); i++) {
			if (m_outputList.get(i).m_nUserID == nUserID) {
				m_outputList.get(i).Stop();
				// m_outputList.remove(i);
				break;
			}
		}
	}

	protected void DeleteAVOutput(int nUserID) {
		for (int i = 0; i < m_outputList.size(); i++) {
			if (m_outputList.get(i).m_nUserID == nUserID) {
				m_outputList.get(i).Close();
				m_outputList.remove(i);
				break;
			}
		}
	}

	public VideoPlay InsertOutput(int userid, ViewGroup layout, LayoutParams param) {
		if (m_handle != 0) {
			DeleteOutput(userid);
			AVOutput output = new AVOutput(userid);
			output.m_IAVCallback = m_IAVCallback;
			output.SetAudioParam(m_nAudioCodec, m_nSamlpeRate, m_nChannels, m_nBitRate, m_nBitSample);
			VideoPlay view = null;
			if (m_bHaveVideo == true) {
				output.SetAVModule(this); // gf add
				view = output.InitVideo(m_content, layout, param, m_nVideoWidth, m_nVideoHeight);
				if (m_defaultVideo != null)
					output.AddVideoBuffer(m_defaultVideo, m_defaultVideo.length);
			}
			m_outputList.add(output);

			AVInsertOutput(m_handle, userid);
			output.SetAVCallBack(m_IAVCallback);// gf add

			return view;
		} else
			return null;
	}

	public void DeleteOutput(int userid) {
		if (m_handle != 0) {
			StopAVOutput(userid);

			AVDeleteOutput(m_handle, userid);

			DeleteAVOutput(userid);
			// Log.v("JNI_DEBUG", "DeleteOutput = " + userid);
		}
	}

	public void SetAudioStatus(int userid, int bAudio) {
		if (m_handle != 0) {
			AVSetAudioStatus(m_handle, userid, bAudio);
		}
	}

	public void SetVideoStatus(int userid, int bVideo) {
		if (m_handle != 0) {
			AVSetVideoStatus(m_handle, userid, bVideo);
		}
	}

	public View GetOutputView(int nUserID) {
		AVOutput output = GetOutput(nUserID);
		if (output == null)
			return null;
		return output.m_videoPlay;
	}

	public int GetNetRate() {
		if (m_handle != 0) {
			return AVGetNetRate(m_handle);
		}
		return 0;
	}

	public void InsertInput(boolean bWaveIn)
	{
		if (m_handle == 0)
		{
			return;
		}
		m_bClose = false;//gf add
		DeleteInput();
		m_input = new AVInput();
		m_input.m_AVModuel = this;
		if (!bWaveIn)
		{
			AVSetNS(m_handle, 1);
		}
		m_input.InitAudio(m_nAudioCodec, m_nSamlpeRate, m_nChannels, m_nBitRate, m_nBitSample, bWaveIn);

		AVInsertInput(m_handle);
	}

	public void DeleteInput() {
		if (m_handle == 0) {
			return;
		}

		if (m_input != null) {
			m_input.Close();
			m_input = null;
		}
		AVDeleteInput(m_handle);
	}

	public void AddInputAudioData(byte[] data, int dataLength) {
		if (m_handle == 0)
			return;
		if (m_input != null) {
			// Log.v("JNI_DEBUG", "AddInputAudioData " + dataLength + "    " +
			// m_nAudioFrameSize);
			AVAddAudioData(m_handle, data, dataLength, m_nAudioFrameSize);
		}
	}

	public void AddInputAudioDataEx(byte[] data, int dataLength, byte[] otherData, int otherDataLength) {
		if (m_handle == 0)
			return;
		if (m_input != null)
			AVAddAudioDataEx(m_handle, data, dataLength, otherData, otherDataLength);
	}

	public int GetAudioEncodeFrameSize() {
		return m_nAudioFrameSize;
	}

	public void SetBaseInfo(String szServerIP, int port, int roomid, int userid, int bufferTime) {
		if (m_handle == 0)
			return;
		AVSetBaseInfo(m_handle, szServerIP, port, roomid, userid, bufferTime);
	}

	public void SetInputAudioStatus(int nStatus) {
		if (m_handle == 0)
			return;
		if (m_input != null) {
			if (nStatus == 1) {
				m_input.AudioStart();
			} else {
				m_input.AudioStop();
			}
		}
		AVSetInputAudioStatus(m_handle, nStatus);
	}

	public int AddVideoData(byte[] data, int dataLength, int nEncode, int nIFrame) {
		// Log.e("AddVideoData", "AddVideoData " + dataLength);
		if (m_handle == 0)
			return 0;
		if ((m_input != null) && (m_bClose == false)) // gf add
		{
			// Log.e("AddVideoData222222222222222", "AddVideoData " +
			// dataLength);
			return AVAddVideoData(m_handle, data, dataLength, nEncode, nIFrame);
		} else {
			return 0;
		}
	}
}
/*
 * public void SetOutputSeteroEffect(boolean bOpen, int nDaley, float fBalance)
 * { m_bOutputStereoEffect = bOpen; m_nOutputStereoDelay = nDaley;
 * m_fOutputStereoBalance = fBalance; for (int i = 0; i < m_outputList.size(); i
 * ++) { m_outputList.get(i).SetOutputSeteroEffect(bOpen, nDaley, fBalance); } }
 */

