package com.TianGe9158;

//import android.content.Context;
//import android.view.View;
import android.app.Activity;
import android.util.Log;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;

public class AVOutput {
	public VideoPlay m_videoPlay = null;
	public AudioPlay m_audioPlay = null;
	public AVModule m_AVModuel = null;
	public int m_nUserID = 0;
	protected Activity m_content = null;
	boolean m_bInitAudio = false;
	public boolean m_bStop = false;

	int m_nCodec = 0;
	int m_nSampleRate = 0;
	int m_nChannels = 0;
	int m_nBitRate = 0;
	int m_nBitSample = 0;
	public IAVCallback m_IAVCallback = null;
	
	boolean m_bHaveVideo = false;//gf add 
	int m_nVideoFrameCount = 0;//gf add

	public AVOutput(int nUserID) {
		m_bStop = false;
		m_nUserID = nUserID;
	}

	//gf add 
	//++++++++++++++++++++++++++++++++++
	public void SetAVCallBack(IAVCallback AvCallBack)
	{
		m_IAVCallback = AvCallBack;
	}
	
	public void SetVideoDataStatus(boolean nStatus)
	{
		m_bHaveVideo = nStatus;
	}
	
	//+++++++++++++++++++++++++++++++++++
	
	public void AddVideoBuffer(byte[] buffer, int length)
	{
		//Log.e("!!!AddVideoBuffer", "!!!!!AddVideoBuffer");
		 
		if (!m_bStop && m_videoPlay != null) 
		{	
			m_videoPlay.AddVideoBuffer(buffer, length);
		}
	}

	public void AddAudioBuffer(byte[] buffer, int length, byte[] otherBuffer, int otherLength)
	{
		// Log.e("AddAudioBuffer", "!!!!!AddAudioBuffer");
	
		if (!m_bStop) 
		{
			//gf add
			//+++++++++++++++++++++
			if(m_bHaveVideo == false)
			{
				return ;
			}
			//+++++++++++++++++++++
			InitAudio();
			m_audioPlay.AddBuffer(buffer, length, otherBuffer, otherLength);
		}
	}

	public int GetWaveBufferCount() {
		if (m_audioPlay != null)
			return m_audioPlay.GetWaveBufferCount();
		else
			return 0;
	}

	public VideoPlay InitVideo(Activity content, ViewGroup layout, LayoutParams param, int srcWidth, int srcHeight) {
		m_bStop = false;
		m_content = content;
		m_videoPlay = new VideoPlay(content);
		m_videoPlay.Init(srcWidth, srcHeight);
		// m_content.getWindow().getWindowManager().addView(m_videoPlay, param);
		// m_content.addContentView(m_videoPlay, param);
		if (layout != null)
			layout.addView(m_videoPlay, param);
		else
			m_content.addContentView(m_videoPlay, param);

		m_videoPlay.SetAVModule(m_AVModuel);// gf add

		return m_videoPlay;
	}

	public void SetAVModule(AVModule avModule) {
		m_AVModuel = avModule;
	}

	public void SetAudioParam(int nCodec, int nSampleRate, int nChannels, int nBitRate, int nBitSample) {
		m_nCodec = nCodec;
		m_nSampleRate = nSampleRate;
		m_nChannels = nChannels;
		m_nBitRate = nBitRate;
		m_nBitSample = nBitSample;
	}

	// void InitAudio(int nCodec, int nSampleRate, int nChannels, int nBitRate,
	// int nBitSample)
	void InitAudio() {
		if (!m_bInitAudio) {
			m_audioPlay = new AudioPlay();
			m_audioPlay.m_IAVCallback = m_IAVCallback;
			m_audioPlay.Init(m_nCodec, m_nSampleRate, m_nChannels, m_nBitRate, m_nBitSample);
			m_bInitAudio = true;
		}
	}

	public void Stop() {
		m_bStop = true;
		if (m_videoPlay != null)
			m_videoPlay.Stop();
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (m_videoPlay != null) {
			ViewGroup vg = (ViewGroup) (m_videoPlay.getParent());
			vg.removeView(m_videoPlay);
		}
		if (m_audioPlay != null) {
			m_audioPlay.Stop();
		}
	}

	public void Close() {
		/*
		 * if (m_videoPlay != null) { //m_content.getLayoutInflater().
		 * //m_content.getWindow().getWindowManager().removeView(m_videoPlay);
		 * //m_videoPlay.setVisibility(GONE); ViewGroup vg =
		 * (ViewGroup)(m_videoPlay.getParent()); vg.removeView(m_videoPlay);
		 * 
		 * m_videoPlay = null; }
		 */
		if (m_videoPlay != null) {
			m_videoPlay.Close();
			m_videoPlay = null;
		}
		if (m_audioPlay != null) {
			// m_audioPlay.Stop();
			// sleep(100);
			m_audioPlay.Close();
			m_audioPlay = null;
		}
	}
	/*
	 * public void SetOutputSeteroEffect(boolean bOpen, int nDaley, float
	 * fBalance) { if (m_audioPlay != null) m_audioPlay.SetOutputSeteroEffect(
	 * bOpen, nDaley, fBalance); }
	 */
}
