package com.TianGe9158;

import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder;

public class AudioIn extends Thread {
	private int Channel_In_Configuration = AudioFormat.CHANNEL_IN_STEREO;// CHANNEL_IN_MONO;//CHANNEL_IN_STEREO;
	private final static int AudioEncoding = AudioFormat.ENCODING_PCM_16BIT;
	private AudioRecord m_AudioRecorder = null;
	boolean m_bStop = false;
	boolean m_bPlay = false;
	int m_nStatus = 0;

	int m_nCodec = 0;
	int m_nSampleRate;
	int m_nChannels;
	int m_nBitSample;
	int m_nBitRate;

	int m_nFrameSize = 0;

	private int m_in_buf_size = 0;
	private byte[] m_recodeBuf = null;
	AVModule m_avmodule = null;
	byte[] m_test = new byte[5];

	public AudioIn() {
		m_test[0] = 1;
		m_test[1] = 2;
		m_test[2] = 3;
		m_test[3] = 4;
		m_test[4] = 5;
	}

	public void Stop() {
		m_bStop = true;
		// if (m_nStatus == 0)

	}

	public void Close() {
		if (m_AudioRecorder != null) {
			Stop();
			if (m_nStatus != 0) {
				try {
					Thread.sleep(200);
					if (m_nStatus != 0)
						interrupt();
					m_nStatus = 0;
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			m_AudioRecorder.stop();
			m_AudioRecorder.release();
			m_AudioRecorder = null;
		}
	}

	public boolean Init(int nCodec, int nSampleRate, int nChannels,
			int nBitRate, int nBitSample) {
		Stop();
		m_nCodec = nCodec;
		m_nSampleRate = nSampleRate;
		m_nChannels = nChannels;
		m_nBitRate = nBitRate;
		m_nBitSample = nBitSample;
		m_bStop = false;
		m_bPlay = false;

		switch (nCodec) {
		case 0:
			m_nFrameSize = 2304 * 2;

			break;
		case 1:
		case 5:
		case 7:
			m_nFrameSize = 1024 * 4 * m_nChannels;

			break;
		case 2:
			m_nFrameSize = (nSampleRate * 4) / 50;
			break;
		case 6:
			m_nFrameSize = 512 * 4 * m_nChannels;

			break;
		}

		if (m_nFrameSize <= 0)
			return false;

		m_in_buf_size = m_nFrameSize;
		if (m_nChannels == 2) {
			Channel_In_Configuration = AudioFormat.CHANNEL_IN_STEREO;
		} else {
			Channel_In_Configuration = AudioFormat.CHANNEL_IN_MONO;
		}
		// nSampleRate = 22050;
		int bufsize = AudioRecord.getMinBufferSize(nSampleRate,// ÿ8K
				Channel_In_Configuration,// ˫
				AudioEncoding);//

		while (m_in_buf_size < bufsize) {
			m_in_buf_size += m_nFrameSize;
		}

		m_AudioRecorder = new AudioRecord(MediaRecorder.AudioSource.MIC,
				m_nSampleRate, Channel_In_Configuration, AudioEncoding,
				m_in_buf_size);

		if (m_AudioRecorder.getState() == AudioRecord.STATE_INITIALIZED) {
			m_recodeBuf = new byte[m_in_buf_size];
			start();
			return true;
		} else
			return false;

	}

	public void run() {
		System.out.println("Record startRecording");
		m_AudioRecorder.startRecording();
		m_bPlay = true;
		m_nStatus = 1;
		while ((!interrupted()) && !m_bStop) {
			if (m_bPlay == false) {
				try {
					Thread.sleep(150);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				continue;
			}
			// System.out.println("m_AudioRecorder.read;");
			int nReadBytes = m_AudioRecorder
					.read(m_recodeBuf, 0, m_in_buf_size);
			// System.out.println("m_AudioRecorder.read;");
			if (AudioRecord.ERROR_INVALID_OPERATION != nReadBytes) {
				// if (nReadBytes != m_in_buf_size)
				// System.out.println("m_AudioRecorder.read 111;" + nReadBytes +
				// " " + m_in_buf_size);
				if (m_avmodule != null) {
					m_avmodule.AddInputAudioData(m_recodeBuf, m_in_buf_size);

					// m_avmodule.AddInputAudioDataEx(m_recodeBuf,
					// m_in_buf_size, m_test, 5);
				}
			}

			// System.out.println("nReadBytes len = "+nReadBytes);
			// curCallLink.getOutputStream().write(compressedVoice, 0, b);
		}

		m_nStatus = 0;
		// Log.v("JNI_DEBUG", "audio record thread end!");
	}

	public void Pause() {
		if (m_AudioRecorder != null) {
			if (m_bPlay == true) {
				m_bPlay = false;
				m_AudioRecorder.stop();
			}
		}
	}

	public void Record() {
		if (m_AudioRecorder != null) {
			if (m_bPlay == false) {
				m_bPlay = true;
				m_AudioRecorder.startRecording();
			}
		}
	}
}
