package com.TianGe9158;

import java.util.ArrayList;
import java.util.List;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.util.Log;

class AudioBufList {
	int m_nWaveBuffer = 0;
	List<AudioPlayBuffer> m_outputList = new ArrayList<AudioPlayBuffer>();

	public void init() {
		m_nWaveBuffer = 0;
		if (!m_outputList.isEmpty()) {
			m_outputList.removeAll(m_outputList);

		}
	}

	public void add(AudioPlayBuffer buf) {
		m_outputList.add(buf);
		m_nWaveBuffer++;
	}

	public AudioPlayBuffer remove(int nIndex) {
		if (!m_outputList.isEmpty()) {
			return m_outputList.remove(nIndex);
		} else {
			return null;
		}
	}

	public void sub() {
		if (m_nWaveBuffer > 0) {
			m_nWaveBuffer--;
		}
	}

	public int getCount() {
		return m_nWaveBuffer;
	}

	public int getListCount() {
		return m_outputList.size();
	}
};

public class AudioPlay extends Thread {
	AudioTrack m_out_trk = null;

	int m_nFrameSize = 0;// 2304 * 2;
	static int m_nBufferMaxPos = 1;
	int m_out_buf_size = 0;// m_nFrameSize * m_nBufferMaxPos;
	// List <AudioPlayBuffer> m_outputList = new ArrayList<AudioPlayBuffer>();
	// byte[] m_out_buf = null;// new byte[m_out_buf_size];
	// int m_nWaveBuffer = 0;
	AudioBufList m_bufList = new AudioBufList();
	int m_nBufferPos = 0;
	boolean m_bStop = false;
	boolean m_bPlay = false;
	int m_nCodec = 0;
	int m_nSampleRate = 0;
	int m_nChannels = 0;
	int m_nBitRate = 0;
	int m_nBitSample = 0;
	boolean m_bOutputStereoEffect = false;
	int m_nOutputStereoDelay = 5;
	float m_fOutputStereoBalance = (float) 0.7;

	public IAVCallback m_IAVCallback = null;

	public boolean Init(int nCodec, int nSampleRate, int nChannels,
			int nBitRate, int nBitSample) {
		Stop();
		m_nCodec = nCodec;
		m_nSampleRate = nSampleRate;
		m_nChannels = nChannels;
		if (nChannels == 1 || nCodec == 1 || nCodec == 5)
			m_nChannels = 2;
		m_nBitRate = nBitRate;
		m_nBitSample = nBitSample;
		m_bStop = false;
		m_bPlay = false;
		int buf_size = 0;
		m_bufList.init();

		switch (nCodec) {
		case 0:
			m_nFrameSize = 2304 * 2;
			buf_size = m_nFrameSize * 3;
			break;
		case 1:
		case 5:
		case 7:
			m_nFrameSize = 1024 * 4 * m_nChannels;
			buf_size = m_nFrameSize * 2;
			break;
		case 2:
			m_nFrameSize = (nSampleRate * 4) / 50;
			buf_size = m_nFrameSize * 4;
			break;
		case 6:
			m_nFrameSize = 512 * 4 * m_nChannels;
			buf_size = m_nFrameSize * 4;
			break;
		}

		if (m_nFrameSize <= 0)
			return false;

		m_out_buf_size = m_nFrameSize * m_nBufferMaxPos;

		int bufsize = AudioTrack.getMinBufferSize(nSampleRate,// ÿ8K

				AudioFormat.CHANNEL_CONFIGURATION_STEREO,// ˫

				AudioFormat.ENCODING_PCM_16BIT);//
		if (buf_size < bufsize)
			buf_size = bufsize;
		// m_out_buf = new byte[m_out_buf_size];
		m_out_trk = new AudioTrack(AudioManager.STREAM_MUSIC, nSampleRate,
				m_nChannels == 1 ? AudioFormat.CHANNEL_CONFIGURATION_MONO
						: AudioFormat.CHANNEL_CONFIGURATION_STEREO,// CHANNEL_CONFIGURATION_STEREO,
																	// //
																	// CHANNEL_CONFIGURATION_MONO,
				AudioFormat.ENCODING_PCM_16BIT, buf_size,// m_out_buf_size,//m_out_buf_size,
				AudioTrack.MODE_STREAM);
		if (m_out_trk != null) {
			start();
			return true;
		} else
			return false;
	}

	public void Play() {
		if (m_out_trk != null) {
			// m_out_trk.play();
			// m_out_trk.pause();

			// -----------------------------------------
			// if (m_out_trk.setPositionNotificationPeriod(m_out_buf_size / 4)
			// == m_out_trk.ERROR_INVALID_OPERATION)
			// repalced by zff 2016.07.16

			if (m_out_trk.setPositionNotificationPeriod(m_nFrameSize
					/ (m_nBitSample * m_nChannels / 8)) == m_out_trk.ERROR_INVALID_OPERATION)
			// -----------------------------------------
			{
				Log.v("JNI_DEBUG", "setPositionNotificationPeriod error ");
			}
			m_out_trk
					.setPlaybackPositionUpdateListener(new AudioTrack.OnPlaybackPositionUpdateListener() {
						public void onMarkerReached(AudioTrack track) {
							// -----------------------------------------
							// m_nWaveBuffer --;
							// track.setNotificationMarkerPosition(m_out_buf_size);
							// marked by zff 2016.07.16
							// -----------------------------------------
							// Log.v("JNI_DEBUG", "onMarkerReached = " +
							// m_nWaveBuffer + " time= " +
							// System.currentTimeMillis());
						}

						public void onPeriodicNotification(AudioTrack track) {
							// TODO Auto-generated method stub
							// -----------------------------------------
							// if (m_nWaveBuffer > 0)
							// m_nWaveBuffer --;
							// replaced by zff 2016.07.16
							synchronized (m_bufList) {
								m_bufList.sub();
							}
							// -----------------------------------------
							// m_out_trk.setPositionNotificationPeriod(m_nFrameSize);
							// Log.v("JNI_DEBUG", "m_nWaveBuffer = " +
							// m_nWaveBuffer);
						}
					});
			m_out_trk.play();
			// m_out_trk.setNotificationMarkerPosition(m_out_buf_size);
		}
	}

	public void Stop() {
		m_bStop = true;
		if (m_out_trk != null) {
			m_out_trk.stop();
			m_bPlay = false;
			// m_out_trk.release();
			// m_out_trk = null;
			// m_nWaveBuffer = 0;
		}
	}

	public void Close() {
		m_out_trk.release();
		m_out_trk = null;
	}

	public void AddBuffer(byte[] buffer, int length, byte[] otherBuffer,
			int otherLength) {
		if (length != m_nFrameSize)
			return;
		if (m_out_trk != null) {
			// Log.v("JNI_DEBUG", "m_nWaveBuffer = " + m_nBufferPos);
			try {
				AudioPlayBuffer audioBuffer = new AudioPlayBuffer();
				audioBuffer.SetBuffer(buffer);
				if (otherLength > 0)
					audioBuffer.SetOtherBuffer(otherBuffer, otherLength);
				// -----------------------------------------
				// m_nWaveBuffer += m_nBufferMaxPos;
				// m_outputList.add(audioBuffer);
				// replaced by zff 2016.07.16
				synchronized (m_bufList) {
					m_bufList.add(audioBuffer);
				}
				// -----------------------------------------

				// Log.v("JNI_DEBUG", "audio thread add!");
				/*
				 * if (!m_outputList.add(buffer.clone())) { //
				 * Log.v("JNI_DEBUG", "audio thread add error!"); } else {
				 * m_nWaveBuffer += m_nBufferMaxPos; }
				 */
			} catch (Exception e) {
				Log.v("JNI_DEBUG", "m_outputList add error!");
			}
			/*
			 * System.arraycopy(buffer, 0, m_out_buf, m_nFrameSize *
			 * m_nBufferPos, m_nFrameSize); m_nBufferPos ++; if (m_nBufferPos ==
			 * m_nBufferMaxPos) { m_nBufferPos = 0;
			 * 
			 * try { //Log.v("JNI_DEBUG", "audio thread add!"); if
			 * (!m_outputList.add(m_out_buf.clone())) { // Log.v("JNI_DEBUG",
			 * "audio thread add error!"); } else { m_nWaveBuffer += 2; } }
			 * catch(Exception e) { Log.v("JNI_DEBUG",
			 * "m_outputList add error!"); } }
			 */
		}
	}

	public int GetWaveBufferCount() {
		// -----------------------------------------
		// if (m_out_trk != null)
		// {
		// return m_nWaveBuffer;
		// }
		// return 0;
		// replaced by zff 2016.07.16
		int nCount = 0;
		synchronized (m_bufList) {
			nCount = m_bufList.getCount();
		}

		// Log.v("JNI_DEBUG",
		// " m_bufList.getCount() m_bufList.getCount();m_nWaveBuffer = "
		// + nCount);
		int n = m_bufList.getListCount();
		// Log.v("JNI_DEBUG",
		// " m_bufList.getListCount() m_bufList.getListCount();putList.size = "
		// + n);

		return nCount;
		// -----------------------------------------
	}

	public void run() {
		Log.v("JNI_DEBUG", "audio thread run()!");
		// m_out_trk.play();
		// Play();
		int nWrite = 0;
		long time1 = 0;
		boolean bStart = false;
		while (!m_bStop) {
			if (bStart == false) {
				// -----------------------------------------
				// if (m_outputList.size() < 3)
				// replaced by zff 2016.07.16
				int nListCount = 0;
				synchronized (m_bufList) {
					nListCount = m_bufList.getListCount();
				}
				if (nListCount < 3)
				// -----------------------------------------
				{
					try {
						Thread.sleep(10);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						//e.printStackTrace();
					}
					continue;
				} else {
					bStart = true;
					Play();
				}
			}

			// -----------------------------------------
			/*
			 * if (!m_outputList.isEmpty()) { // Log.v("JNI_DEBUG",
			 * "audio thread write!"); while (!m_outputList.isEmpty()) { //
			 * time1 = System.currentTimeMillis(); try { AudioPlayBuffer buffer
			 * = m_outputList.remove(0); nWrite =
			 * m_out_trk.write(buffer.m_buffer, 0, m_nFrameSize); if
			 * (m_IAVCallback != null && buffer.m_otherBuffer != null) {
			 * m_IAVCallback.OnAudioOtherData(buffer.m_otherBuffer); } }
			 * catch(Exception e) { Log.v("JNI_DEBUG",
			 * "audioplay write error!"); break; }
			 * 
			 * // Log.v("JNI_DEBUG", "AudioTrack write = " + nWrite + " + " +
			 * (System.currentTimeMillis() - time1)); /* try {
			 * m_outputList.remove(0);
			 * 
			 * } catch(Exception e) { Log.v("JNI_DEBUG",
			 * "m_outputList remove error!"); break; }
			 */
			// m_nWaveBuffer ++;
			/*
			 * if (m_bPlay == false && m_nWaveBuffer >= 1) { m_out_trk.play();
			 * m_bPlay = true; }
			 */
			AudioPlayBuffer buffer = null;
			synchronized (m_bufList) {
				buffer = m_bufList.remove(0);
			}
			if (buffer != null) {
				try {
					nWrite = m_out_trk.write(buffer.m_buffer, 0, m_nFrameSize);
					if (m_IAVCallback != null && buffer.m_otherBuffer != null) {
						m_IAVCallback.OnAudioOtherData(buffer.m_otherBuffer);
					}
				} catch (Exception e) {
					Log.v("JNI_DEBUG", "audioplay write error!");
					break;
					// -----------------------------------------
				}
			} else {
				// Log.v("JNI_DEBUG", "m_outputList is empty!");
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		// Log.v("JNI_DEBUG", "audio thread end!");
	}
	/*
	 * public void SetOutputSeteroEffect(boolean bOpen, int nDaley, float
	 * fBalance) {
	 * 
	 * }
	 */
}
