package com.TianGe9158;

import java.io.IOException;

import android.app.Activity;
import android.graphics.ImageFormat;
import android.hardware.Camera;
import android.hardware.Camera.CameraInfo;
import android.hardware.Camera.PreviewCallback;
import android.os.Build;
import android.view.Surface;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.Toast;

//Ƶɼط࣬ɼƵطţCallbackеH.264룬͵ģ
public class CameraPreview extends SurfaceView implements
		SurfaceHolder.Callback {

	protected Activity mActivity;
	private SurfaceView mSurfaceView;
	private SurfaceHolder mSurfaceHolder;

	private LayoutParams m_SurfaceViewParams;// ƵLayoutС
	int m_nCapPrewWidth = 1;
	int m_nCapPrewHeight = 1;

	protected Camera mCamera;
	private int mCameraId;//ͷID, һ0Ϊã1Ϊǰ
	
	Camera.PreviewCallback mCallback = null;
	boolean mStart = false;
	
	// 캯
	public CameraPreview(Activity activity, ViewGroup viewGroup, int nWidth,
			int nHeight) {
		
		super(activity);
		mActivity = activity;
		mSurfaceView = new SurfaceView(mActivity);//
		LayoutParams params;
		params = new LayoutParams(nWidth, nHeight);
		if (viewGroup != null)
			viewGroup.addView(mSurfaceView);
		else
			activity.addContentView(mSurfaceView, params);
		m_SurfaceViewParams = mSurfaceView.getLayoutParams();
		m_nCapPrewWidth = m_SurfaceViewParams.width;
		m_nCapPrewHeight = m_SurfaceViewParams.height;
		m_SurfaceViewParams.width = nWidth; // ɰwidth heightΪ1
		m_SurfaceViewParams.height = nHeight;

		mSurfaceHolder = mSurfaceView.getHolder();
		mSurfaceHolder.addCallback(this);
		mSurfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);

		
		
		
		
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		Camera.Parameters CameraCapParam = mCamera.getParameters();

		CameraCapParam.setPreviewSize(width, height);
		CameraCapParam.setPreviewFrameRate(10);// nFrameRateһҪ10óɹ
		
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD) {
			CameraCapParam.setPreviewFormat(ImageFormat.YV12);// AndroidĬΪYUV420SPʽҪΪYV12ʽбҪҪU/VΪYUV420
        } else {
        	CameraCapParam.setPreviewFormat(ImageFormat.NV21); 
        }
        
		

		mCamera.setParameters(CameraCapParam);
		if (mCallback != null)
			setPreviewCallback(mCallback);
		if (mStart)
			startPreview();
	}

	@Override
	public void surfaceCreated(SurfaceHolder arg0) {
		//API汾Ŵڵ9ֶ֧ͷ
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD) {
			mCameraId = getDefaultCameraId();
		} else {
			mCameraId = 0;
		}
		
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD) {
			mCamera = Camera.open(mCameraId); //API>=9
        } else {
        	mCamera = Camera.open();          //API<9
        }
		
		// API汾Ŵڵ9ֶ֧ͷ
		/*if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD) {
			setCameraDisplayOrientation(mActivity, mCameraId, mCamera);
		}*/
		
		
		try {
			mCamera.setPreviewDisplay(mSurfaceHolder);
		} catch (IOException e) {
			mCamera.release();
			mCamera = null;
		}
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder arg0) {
		if (null == mCamera) {
			return;
		}
		mCamera.stopPreview();
		mCamera.release();
		mCamera = null;
	}

	public void setPreviewCallback(PreviewCallback callback) {
		mCallback = callback;
		if (null == mCamera) {
		
			return;
		}
		mCamera.setPreviewCallback(callback);
	}

	public void startPreview() {
		mStart = true;
		if (null == mCamera) {
			return;
		}
		System.out.println("mCamera.startPreview()");

		mCamera.startPreview();
	}

	public void stopPreview() {
		mStart = false;
		if (null == mCamera) {
			return;
		}
		System.out.println("mCamera.stopPreview()");
		mCamera.stopPreview();
	}

	public void release() {
		mStart = false;
		if (null == mCamera) {
			return;
		}
		mCamera.stopPreview();
		System.out.println("mCamera.release()");
		mCamera.release();
		mCamera = null;
	}

	private int getDefaultCameraId() {
		int defaultId = -1;

		// Find the total number of cameras available
		int mNumberOfCameras = android.hardware.Camera.getNumberOfCameras();

		android.hardware.Camera.CameraInfo cameraInfo = new android.hardware.Camera.CameraInfo();
		// Find the ID of the default camera
		for (int i = 0; i < mNumberOfCameras; i++) {
			android.hardware.Camera.getCameraInfo(i, cameraInfo);
			if (cameraInfo.facing == CameraInfo.CAMERA_FACING_BACK) {
				defaultId = i;
			}
		}
		if (-1 == defaultId) {
			if (mNumberOfCameras > 0) {
				// ûкͷ
				defaultId = 0;
			} else {
				// ûͷ
				Toast.makeText(mActivity, "ûͷ", Toast.LENGTH_LONG).show();
			}
		}
		return defaultId;
	}

	private static void setCameraDisplayOrientation(Activity activity,
			int cameraId, Camera camera) {
		Camera.CameraInfo info = new Camera.CameraInfo();
		Camera.getCameraInfo(cameraId, info);
		int rotation = activity.getWindowManager().getDefaultDisplay()
				.getRotation();
		int degrees = 0;
		switch (rotation) {
		case Surface.ROTATION_0:
			degrees = 0;
			break;
		case Surface.ROTATION_90:
			degrees = 90;
			break;
		case Surface.ROTATION_180:
			degrees = 180;
			break;
		case Surface.ROTATION_270:
			degrees = 270;
			break;
		}

		int result;
		if (info.facing == Camera.CameraInfo.CAMERA_FACING_FRONT) {
			result = (info.orientation + degrees) % 360;
			result = (360 - result) % 360; // compensate the mirror
		} else { // back-facing
			result = (info.orientation - degrees + 360) % 360;
		}
		camera.setDisplayOrientation(result);
	}
}
